Public Class FrmRepositories

    Private Sub FrmRepositories_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If IsNothing(TempList) = False Then
            TempList.TBL_DOC_CATTableAdapter.Fill(TempList.DsTempList.TBL_DOC_CAT)
            TempList.TBL_DOC_SUB_CATTableAdapter.Fill(TempList.DsTempList.TBL_DOC_SUB_CAT)


        End If
    End Sub

    Private Sub FrmRepositories_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'TODO: This line of code loads data into the 'DsTempList.TBL_DOC_CAT' table. You can move, or remove it, as needed.
        Me.TBL_DOC_CATTableAdapter.Fill(Me.DsTempList.TBL_DOC_CAT)
        Me.DsTempList.TBL_DOC_CAT.AcceptChanges()



    End Sub
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub

    Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
        If Me.txtRepositoryName.Text.Trim = "" Then
            MessageBox.Show("Invalid Repository Name", "Virutal Desk", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Exit Sub
        End If
        If Me.txtRepositoryDesc.Text.Trim = "" Then
            MessageBox.Show("Invalid Repository Description", "Virutal Desk", MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Exit Sub
        End If
        If Me.chkActive.CheckState = CheckState.Indeterminate Then
            Me.chkActive.Checked = True
        End If
        Me.TBLDOCCATBindingSource.EndEdit()
        Me.TBL_DOC_CATTableAdapter.Update(Me.DsTempList.TBL_DOC_CAT)
    End Sub

    Private Sub btnManageSubCat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnManageSubCat.Click
        If DataGridView1.SelectedRows.Count > 0 Then
            Dim frmSubRep As New FrmSubRepositories
            frmSubRep.MdiParent = FrmMain
            frmSubRep.DOC_CAT_ID = DataGridView1.SelectedCells.Item(0).Value
            frmSubRep.Show()
            frmSubRep.Select()
        End If
    End Sub

    Private Sub btnAddNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddNew.Click
        Me.TBLDOCCATBindingSource.AddNew()
        Me.btnManageSubCat.Enabled = False
        Me.btnDelete.Enabled = False
        Me.btnCancel.Enabled = True
        chkActive.Checked = False
    End Sub

    Private Sub DataGridView1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataGridView1.Click
        If DataGridView1.SelectedRows.Count > 0 Then
            Me.btnManageSubCat.Enabled = True
            Me.btnDelete.Enabled = True
            Me.btnCancel.Enabled = False
        End If
    End Sub

    Private Sub btnDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDelete.Click
        If MessageBox.Show("Are You Want Delete Selected Category?", "Virtual Desk", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
            Dim cdata As New Data
            cdata.DS_Read("DELETE TBL_DOC_CAT WHERE DOC_CAT_ID=" & DataGridView1.SelectedCells.Item(0).Value, "DSDELETE")
            Me.TBL_DOC_CATTableAdapter.Fill(Me.DsTempList.TBL_DOC_CAT)
            Me.DsTempList.TBL_DOC_CAT.AcceptChanges()
        End If
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click
        Me.TBLDOCCATBindingSource.CancelEdit()
    End Sub
End Class